#include<bits/stdc++.h>
using namespace std;

char Small(char c) {
    if (c >= 'A' && c <= 'Z') {
        return c - 'A' + 'a';
    }
    return c;
}

set<string> SentToSetWord(const string &s) {
    string word;
    set<string> ans;
    for (int i = 0; i < s.size(); ++i) {
        if (isalpha(s[i])) {
            word += Small(s[i]);
        } else if (word != "") {
            ans.insert(word);
            word.clear();
        }
    }
    if (word != "") {
        ans.insert(word);
        word.clear();
    }
    return ans;
}

bool NextSymbolSmall(int i, const string &text) {
    ++i;
    for (; i < text.size() && text[i] == ' '; ++i);
    if (i < text.size() && text[i] >= 'a' && text[i] <= 'z') {
        return true;
    } else {
        return false;
    }
}

void PrintStart(const string &s) {
    cout << "Search results for \"" << s << "\":" << endl;
}

void Print(const string &s) {
    cout << "- \"" << s << '"' << endl;
}

void PrintSetWord(const set<string> &word) {
    for (const auto &s : word) {
        cerr << s << endl;
    }
    cerr << endl;
}

void DeleteBack(string &s) {
    while (s.back() == ' ') {
        s.pop_back();
    }
}

void DeleteFront(string &s) {
    reverse(s.begin(), s.end());
    DeleteBack(s);
    reverse(s.begin(), s.end());
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    vector<string> m_sent;
    vector<set<string>> m_word;
    string text, sent;
    getline(cin, text);
    for (int i = 0; i < text.size(); ++i) {
        if (sent.empty() && text[i] == ' ')
            continue;
        sent += text[i];
        if (text[i] == '?' ||
            text[i] == '!' ||
            (text[i] == '.' && !NextSymbolSmall(i, text))) {
            DeleteBack(sent);
            m_sent.push_back(sent);
            m_word.push_back(SentToSetWord(sent));
            sent.clear();
        }
    }
    DeleteBack(sent);
    if (!sent.empty()) {
        m_sent.push_back(sent);
        m_word.push_back(SentToSetWord(sent));
        sent.clear();
    }
    int n;
    cin >> n;
    string q;
    getline(cin, q);
    for (int i = 0; i < n; ++i) {
        getline(cin, q);
        DeleteBack(q);
        DeleteFront(q);
        set<string> q_word = SentToSetWord(q);
        PrintStart(q);
        for (int j = 0; j < m_sent.size(); ++j) {
            int flag = 0;
            for (const auto &s : q_word) {
                flag += m_word[j].count(s);
            }
            if (flag == q_word.size()) {
                Print(m_sent[j]);
            }
        }
    }
    return 0;
}
