#include<bits/stdc++.h>
using namespace std;

map<string, int> fen;
string max_el, el_0;
int f(char x) {
    return x - '0';
}

string operator | (const string& s1, const string &s2) {
    string res;
    for (int i = 0; i < s1.size(); ++i) {
        res += '0' + (f(s1[i]) | f(s2[i]));
    }
    return res;
}

string operator & (const string& s1, const string &s2) {
    string res;
    for (int i = 0; i < s1.size(); ++i) {
        res += '0' + (f(s1[i]) & f(s2[i]));
    }
    return res;
}

string operator + (const string& s1, int x) {
    string res = s1;
    for (int i = s1.size() - 1; i >= 0; --i) {
        if (s1[i] == '1') {
            res[i] = '0';
        } else {
            res[i] = '1';
            break;
        }
    }
    return res;
}

string operator - (const string& s1, int x) {
    string res = s1;
    for (int i = s1.size() - 1; i >= 0; --i) {
        if (s1[i] == '0') {
            res[i] = '1';
        } else {
            res[i] = '0';
            break;
        }
    }
    return res;
}

void Add(string i, int x) {
    for (; true; i = i | (i + 1)) {
        fen[i] += x;
        if (i == max_el) {
            break;
        }
    }
}

int Sum(string i) {
    int res = 0;
    for (; ; i = (i & (i + 1)) - 1) {
        res += fen[i];
        if ((i & (i + 1)) == el_0) {
            break;
        }
    }
    return res;
}

string rev(const string &s) {
    string res;
    for(int i = 0; i < s.size(); ++i) {
        res += (s[i] == '0' ? '1' : '0');
    }
    return res;
}

int main()
{
    //freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);
    int n,m ;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        max_el += '1';
        el_0 += '0';
    }
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        cout << i - Sum(rev(s)) << endl;
        Add(s, 1);
    }
    return 0;
}
