#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <utility>
#include <set>
#include <queue>
#include <map>
#include <memory.h>
#include <string>
#include <iomanip>

using namespace std;

const int maxn = 1e5 + 7;

map <int, int> bor[maxn];
int b_size = 1, term[maxn], m, ans;

int f(char c) {
    return int(c) - '0';
}

void Add(string & s) {
    int v = 0;
    for (int i = 0; i < s.size(); ++i) {
        if (bor[v][f(s[i])]) {
            v = bor[v][f(s[i])];
        } else {
            bor[v][f(s[i])] = b_size++;
            v = bor[v][f(s[i])];
        }
    }
    term[v]++;
}

void Check(vector <int> & s, vector <int> & t, int v) {
    if (t > s) {
        return;
    }
    if (t.size() == m) {
        ans += term[v];
        return;
    }
    for (auto a : bor[v]) {
        t.push_back(a.first);
        Check(s, t, a.second);
        t.pop_back();
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        vector <int> v, t;
        for (int j = 0; j < s.size(); ++j) {
            if (s[j] == '0') {
                v.push_back(1);
            } else {
                v.push_back(0);
            }
        }
        ans = 0;
        Check(v, t, 0);
        cout << i - ans << endl;
        cout.flush();
        Add(s);
    }
    return 0;
}
