#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <memory.h>
#include <stdio.h>
#include <string>
#include <cmath>
#include <iomanip>


using namespace std;

const int INF = 1e9 + 7;

bool pos[(1 << 18) + 10][105];
int dp[(1 << 18)];

int main()
{
    //freopen ("input.txt", "r", stdin);
    //freopen ("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    vector <pair <int, int>> mm;
    for (int i = 0; i < m; ++i) {
        int q;
        cin >> q;
        int mask = 0;
        for (int j = 0; j < q; ++j) {
            int x;
            cin >> x;
            mask += (1 << (x - 1));
        }
        int w;
        cin >> w;
        mm.push_back({mask, w});
    }
    for (int i = 0; i < (1 << n); ++i) {
        for (int j = 0; j < m; ++j) {
            int mask = mm[j].first;
            if ((i & mask) == 0) {
                pos[i][j] = 1;
            } else {
                pos[i][j] = 0;
            }
        }
    }
    for (int i = 0; i < (1 << n); ++i) {
        dp[i] = INF;
    }
    dp[0] = 0;
    for (int i = 0; i <= (1 << n); ++i) {
        for (int j = 0; j < m; ++j) {
            int mask = mm[j].first, w = mm[j].second;
            if (pos[i][j]) {
                dp[i | mask] = min(dp[i | mask], dp[i] + w);
            }
        }
    }
    if (dp[(1 << n) - 1] != INF) {
        cout << dp[(1 << n) - 1];
    } else {
        cout << -1;
    }
    return 0;
}
