#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ft first
#define sd second
#define all(x) begin((x)), end((x))
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))

typedef long long ll;
typedef pair<int, int> pii;

char buf[100100];

string get_string()
{
    scanf("%s", buf);
    return string(buf);
}

struct node
{
    int sz;
    int nx[2];
};

int sz;
node bor[300300];

int new_node()
{
    bor[sz].sz = 0;
    bor[sz].nx[0] = bor[sz].nx[1] = -1;
    return sz++;
}

void add(string s)
{
    bor[0].sz++;
    int p = 0;
    for (char ch : s)
    {
        int c = (ch == '1');
        if (bor[p].nx[c] == -1)
            bor[p].nx[c] = new_node();
        p = bor[p].nx[c];
        bor[p].sz++;
    }
}

int get_size(int i)
{
    return i == -1 ? 0 : bor[i].sz;
}

bool is_zero(string& s)
{
    for (char c : s)
        if (c == '1')
            return false;
    return true;
}

int get_ans(string s)
{
    int p = 0;
    int ans = 0;
    for (char ch : s)
    {
        if (p == -1)
            break;
        int c = (ch == '1');
        if (c)
            ans += get_size(bor[p].nx[1]);
        p = bor[p].nx[!c];
    }
    return ans;
}

void solve()
{
    int n, m;
    sz = 0;
    new_node();
    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; ++i)
    {
        string s = get_string();
        int ans = 0;
        if (!is_zero(s))
            ans = get_ans(s),
            add(s);
        printf("%d\n", ans);
        fflush(stdout);
    }
}

// #define LOCAL

int main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    //cin.tie(0);

    solve();

    return 0;
}
