#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ft first
#define sd second
#define all(x) begin((x)), end((x))
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))

typedef long long ll;
typedef pair<int, int> pii;

int64_t fib(int n)
{
    int64_t a = 0;
    int64_t b = 1;
    for (int i = 0; i < n; ++i)
    {
        int64_t c = b;
        b = a + b;
        a = c;
    }
    return a;
}

int subsolve(int64_t a, int64_t b, int64_t c)
{
    a = fib(a);
    b = fib(b);
    c = fib(c);
    b *= b;
    a *= 4*c;
    if (b > a)
        return 2;
    if (b == a)
        return 1;
    return 0;
}

void solve()
{
    int64_t a, b, c;
    cin >> a >> b >> c;
    if (a < 21)
        cout << subsolve(a, b, c) << endl;
    else
        cout << 2*(b == max(a, max(b, c))) << endl;
}

// #define LOCAL

int main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
