#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <stack>
#include <map>

using namespace std;

struct botType{
	int x;
	int y;
	int nx;
	int ny;
	int direction;
};

int main()
{
	int n,type;
	cin>>n>>type;
	if(type==1||type==2){
		vector<vector<int> > v(n);
		for(int i=0;i<n;i++){
			v[i].resize(n);			
		}
		int q=1;
		for(int i=0;i<n;i++){
			for(int j=0;j<n;j++){
				if(type==1){
					if(i%2==0){
						v[i][j]=q;
					}
					else{
						v[i][n-j-1]=q;
					}
				}
				else if(type==2){
					if(i%2==0){
						v[j][i]=q;
					}
					else{
						v[n-j-1][i]=q;
					}
				}
				q++;
			}
		}

		for(int i=0;i<n;i++){
			for(int j=0;j<n;j++){
				cout<<v[i][j];
				if(j<n-1) cout<<" ";
			}
			cout<<endl;
		}
	}
	else{
		int nn=n+2;
		vector<vector<int> > v(nn);
		for(int i=0;i<nn;i++){
			v[i].resize(nn);
			for(int j=0;j<nn;j++){
				if(i==0||i==nn-1||j==0||j==nn-1) v[i][j]=1;
				else v[i][j]=0;
			}
		}

		botType bot;
		bot.x=1;
		bot.y=1;				
		v[1][1]=1;
		if(type==4){
			bot.direction=1;
			bot.nx=2;
			bot.ny=1;
		}
		else if(type==3){
			bot.direction=2;
			bot.nx=1;
			bot.ny=2;
		}
		int q=2;
		while(q<=n*n){
			if(v[bot.nx][bot.ny]==0){
				v[bot.nx][bot.ny]=q;
				q++;
				bot.x=bot.nx;
				bot.y=bot.ny;
			}
			else{
				if(v[bot.x+1][bot.y]==0) bot.direction=1;
				else if(v[bot.x][bot.y+1]==0) bot.direction=2;
				else if(v[bot.x-1][bot.y]==0) bot.direction=3;
				else if(v[bot.x][bot.y-1]==0) bot.direction=4;				
				bot.nx=bot.x;
				bot.ny=bot.y;
			}
			switch(bot.direction){
			case 1: bot.nx++;break;
			case 2: bot.ny++; break;
			case 3: bot.nx--; break;
			case 4: bot.ny--; break;
			}			
		}


		for(int i=1;i<=n;i++){
			for(int j=1;j<=n;j++){
				cout<<v[i][j];
				if(j<n) cout<<" ";
			}
			cout<<endl;
		}
	}
	return 0;
}