#include <iostream>
#include <vector>
#include <map>
#define INT_MAX 0x7fffffff
using namespace std;
struct spells {
	int msk;
	int cst;
	struct spells operator+(struct spells &op) {
		struct spells res;
		if ((this->msk ^ op.msk) == (this->msk + op.msk)) {
			res.cst = this->cst + op.cst;
			res.msk = this->msk + op.msk;
			return res;
		}
		res.cst = INT_MAX;
		res.msk = -1;
		return res;
	}
} sp[101];
//int sp_cmp[101][101];

int main(int argc, char ** argv) {

	int n, m;
	int max_msk;
	cin >> n >> m;
	max_msk = (1 << n) - 1;
	int tmp, mon;
	for (int i = 0; i < m; i++) {
		cin >> tmp;
		for (int j = 0; j < tmp; j++) {
			cin >> mon;
			sp[i].msk += (1 << (mon-1));
		}
		cin >> sp[i].cst;
	}
	//for (int i = 0; i < m; i++) {
	//	for (int j = i+1; j < m; j++) {
	//		if (sp[i].msk^sp[j].msk == sp[i].msk+sp[j].msk) {
	//			sp_cmp[i][j] = 1;
	//			sp_cmp[j][i] = 1;
	//		}
	//	}
	//}
	int min_cst = INT_MAX, tmp_cst;
	vector < map < int, int > > d(2, map < int, int >() );
	for (int i = 0; i < m; i++) {
		d[0].insert(make_pair(sp[i].msk, sp[i].cst));
	}
	struct spells spell, spell2;
	int k = 0, ok = 1;
	while (true) {
		ok = k;
		k ^= 1;
		for (auto i = d[ok].begin(); i != d[ok].end(); i++) {
			spell2.cst = i->second;
			spell2.msk = i->first;
			for (int j = 0; j < m; j++) {
				spell = spell2 + sp[j];
				if (spell.msk == -1) continue;
				if (d[k][spell.msk] > spell.cst) {
					d[k][spell.msk] = spell.cst;
				}
				if (d[k][spell.msk] == 0) {
					d[k][spell.msk] = spell.cst;
				}

			}
		}
		d[ok].clear();
		if (d[k].size() == 0) break;
		tmp_cst = d[k][max_msk];
		if (tmp_cst == 0) continue;
		if (tmp_cst < min_cst) min_cst = tmp_cst;
	}
	if (min_cst == INT_MAX) min_cst = -1;
	cout << min_cst;
	return 0;
}