#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

struct team {
	std::string name;
	int tasks;
	int time;
};

bool compare (const team &lhs, const team&rhs){
	if (lhs.tasks < rhs.tasks) {
		return true;
	}
	else if (lhs.tasks == rhs.tasks && lhs.time > rhs.time) {
		return true;
	}

	return false;
}

void task() {
	int64_t n;
	vector <team> teams;
	cin >> n;
	while (n--) {
		team t;

		cin >> t.name;
		cin >> t.tasks >> t.time;

		teams.push_back(t);
	}

	sort(teams.begin(), teams.end(), compare);

	cout << teams.back().name << endl;
}


int main()
{
	task();
	return 0;
}

