#include <iostream>
#include <vector>

using namespace std;

long long max_num = 1000000000000000000;

void print_vec(vector<bool> &vec) {
    for (int i=0; i<vec.size(); ++i) {
        cout << vec[i] << ' ';
    }
    cout << endl;
}

void print_vec(vector<long long> &vec) {
    for (int i=0; i<vec.size(); ++i) {
        cout << i << " " << vec[i] << endl;
    }
}


int main() {
    int n, m, k, mon_ind;
    cin >> n >> m;

    long long x = 1;
    for (int i = 0; i < n; ++i) {
        x *= 2;
    }

    vector<long long> dyn(x, max_num);
    dyn[0] = 0;
    vector<long long> spells;
    vector<int> en(m);

    for (int i = 0; i < m; ++i) {
        long long mon = 0, pow = 1, idx  = 1;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            cin >> mon_ind;
            while (idx < mon_ind) {
                pow *= 2;
                ++idx;
            }
            mon += pow;
        }
        spells.push_back(mon);
        cin >> en[i];
    }

    for (long long i=1; i<x; ++i) {
        for (int j=0; j<m; ++j) {
            if (spells[j] <= i) {
                dyn[i] = min(dyn[i], dyn[i-spells[j]] + en[j]);
            }
        }
    }

    if (dyn[x-1] != max_num)
        cout << dyn[x-1] << endl;
    else
        cout << -1 << endl;
}
