import java.util.Scanner;
public class Program {
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int size = sc.nextInt();
		int m = sc.nextInt();
		
		if (m == 3) {
			printArr(A3(size), false);
		} else if (m ==4) {
			printArr(A3(size), true);
		} else if (m == 1) {
			printArr(A1(size), false);
		} else if (m == 2) {
			printArr(A1(size), true);
		}
	}
	
	static int[][] A3(int N) {
		int arr[][] = new int[N][N];
		int topBor = 1;
		int botBor = N - 1;
		int leftBor = 0;
		int rightBor = N - 1;
		int horStep = 1;
		int verStep = 1;
		int i = 0, j = 0, c = 1;
		boolean isVerDir = false;
		while (c < N*N + 1) {
			arr[i][j] = c++;
			if (isVerDir) {
				i += verStep;
			} else {
				j += horStep;
			}
			if (j == rightBor && horStep > 0) {
				horStep = -horStep;
				rightBor--;
				isVerDir = !isVerDir;
			} else if (j == leftBor && horStep < 0) {
				horStep = -horStep;
				leftBor++;
				isVerDir = !isVerDir;
			}
			if (i == topBor && verStep < 0) {
				verStep = -verStep;
				topBor++;
				isVerDir = !isVerDir;
			} else if (i == botBor && verStep > 0) {
				verStep = -verStep;
				botBor--;
				isVerDir = !isVerDir;
			}
		}
		return arr;
	}
	
	static int[][] A1(int N) {
		int arr[][] = new int[N][N];
		int c = 1;
		for (int i = 0; i < N; i++) {
			if ((i % 2) == 0) {
				for(int j = 0; j < N; j++) {
					arr[i][j] = c++;
				}
			} else {
				for(int j = N - 1; j >= 0; j--) {
					arr[i][j] = c++;
				}
			}	
		}
		return arr;

	}
	
	
	static void printArr(int[][] arr, boolean trans) {
		for (int i = 0; i < arr.length; i++) {
			for (int j = 0; j < arr.length; j++) {
				System.out.print((trans ? arr[j][i] : arr[i][j]) + " ");
			}
			System.out.println();
		}
	}
}
