#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>

using namespace std;

int main() {
	string s;
	getline(cin, s);
	int start_str = -1, end_str = -1;
	vector <string> v;

	// str to array
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == '?' || s[i] == '!'){
			if (start_str == -1) start_str = i;
			v.push_back(s.substr(start_str, i - start_str + 1));
			start_str = -1;
		} else if (s[i] == '.') {
			if (start_str == -1) start_str = i;
			if (end_str != -1) {
				v.push_back(s.substr(start_str, end_str - start_str + 1));
				end_str = -1;
				start_str = i;
			}
			else {
				end_str = i;
			}
		} else if (s[i] >= 'a' && s[i] <= 'z') {
			if (end_str != -1) {
				end_str = -1;
			}
			if (start_str == -1){
				start_str = i;
			}
		} else if ((s[i] < 'a' || s[i] > 'z') && s[i] != ' ') {
			if (end_str != -1) {
				v.push_back(s.substr(start_str, end_str - start_str + 1));
				end_str = -1;
				start_str = -1;
			}
			if (start_str == -1) start_str = i;
		}
	}
	if (start_str != -1) {
		if (end_str == -1) {
			for (int i = s.size()-1; i >= 0; --i) {
				if (s[i] != ' ') {
					end_str = i;
					break;
				}
			}
			if (end_str == -1) end_str = 0;
		}
		v.push_back(s.substr(start_str, end_str - start_str + 1));
	}

	// cin n
	int n;
	cin >> n;
	getline(cin, s);

	for (int i = 0; i < n; ++i) {
		string q;
		getline(cin, q);
		vector<string> vq; // 32

		// query str to array
		int start_word = -1;
		for (int j = 0; j < q.size(); ++j) {
			if (q[j] >= 'A' && q[j] <= 'z') {
				if (start_word == -1) {
					start_word = j;
				}
			}
			else {
				if (start_word != -1) {
					vq.push_back(q.substr(start_word, j - start_word));
					start_word = -1;
				}
			}
		}
		if (start_word != -1) vq.push_back(q.substr(start_word, q.size() - start_word));

		cout << "Search results for \"" << q << "\":\n";
		// compare
		for (int j = 0; j < v.size(); ++j) {//by strs
			bool ok = true;
			//vector<int> exclude; // 32
			for (int k = 0; k < vq.size(); ++k) {//by words
				int pos = 0;
				bool new_word = true;
				for (int m = 0; m < v[j].size(); ++m) {
					/*bool cont = false;
					for (int l = 0; l < exclude.size(); ++l) {
						if (m == exclude[l]) {
							cont = true;
							break;
						}
					}*/
					/*if (cont) {
						new_word = false;
						continue;
					}*/
					if (v[j][m] == vq[k][pos] || abs(v[j][m] - vq[k][pos]) == 32) {
						if (new_word) pos++;
					} else {
						pos = 0;
						if (v[j][m] < 'A' || v[j][m] > 'z') {
							new_word = true;
						}
						else {
							new_word = false;
						}
					}
					if (pos == vq[k].size()) {
						if (m + 1 == v[j].size() || (v[j][m+1] < 'A' || v[j][m+1] > 'z')) {
							//exclude.push_back(m - pos + 1);
							break;
						}
						new_word = false;
						pos = 0;
					}
				}
				if (pos != vq[k].size()) {
					ok = false;
					break;
				}
			}
			if (ok) {
				cout << "- \"" << v[j] << "\"\n";
			}
		}
	}
	return 0;
}