#include<bits/stdc++.h>
using namespace std;

int a[150][150];

void PrintSnake(int n) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << a[i][j] << ' ';
        }
        cout << endl;
    }
}

void PrintSpirel(int n) {
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            cout << a[i][j] << ' ';
        }
        cout << endl;
    }
}

void f1(int n) {
    int c = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; ++j) {
            a[i][j] = ++c;
        }
        ++i;
        if (i == n) break;
        for (int j = n - 1; j >= 0; --j) {
            a[i][j] = ++c;
        }
    }
    PrintSnake(n);
}

void f2(int n) {
    int c = 0;
    for (int j = 0; j < n; ++j) {
        for (int i = 0; i < n; ++i) {
            a[i][j] = ++c;
        }
        ++j;
        if (j == n) break;
        for (int i = n - 1; i >= 0; --i){
            a[i][j] = ++c;
        }
    }
    PrintSnake(n);
}

void Spiral(int n, const vector<int> &di, const vector<int> &dj) {
    int c = 0;
    memset(a, 1, sizeof(a));
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            a[i][j] = 0;
        }
    }
    int si = 1, sj = 1, q = 0;
    while (c != n * n) {
        //cerr << si << ' ' << sj << ' ' << c << endl;
        a[si][sj] =  ++c;
        if (a[si + di[q]][sj + dj[q]] != 0) {
            q = (q + 1) % 4;
        }
        si += di[q];
        sj += dj[q];
    }
    PrintSpirel(n);
}

void f3(int n) {
    vector<int> di = {0, 1, 0, -1};
    vector<int> dj = {1, 0, -1, 0};
    Spiral(n, di, dj);

}
void f4(int n) {
    vector<int> di = {1, 0, -1, 0};
    vector<int> dj = {0, 1, 0, -1};
    Spiral(n, di, dj);

}
int main()
{
    //freopen("input.txt", "r", stdin);
    int n, a;
    cin >> n >> a;
    if (a == 1) f1(n);
    if (a == 2) f2(n);
    if (a == 3) f3(n);
    if (a == 4) f4(n);
    return 0;
}
