import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Main {

	public static void main(String[] args) {
		Reader in = new Reader(System.in);
		PrintWriter out = new PrintWriter(System.out);
		int n = in.nextInt();
		String bestName = in.next();
		int bestT = in.nextInt();
		int bestT2 = in.nextInt();
		for (int i = 0; i < n-1; i++) {
			String a = in.next();
			int b = in.nextInt();
			int c = in.nextInt();
			if (b>bestT || (b==bestT && c<bestT2)){
				bestName = a;
				bestT = b;
				bestT2 = c;
			}
		}
		out.println(bestName);
		out.close();
	}

}

class Reader{
	BufferedReader reader;
	StringTokenizer line = new StringTokenizer("");
	
	public Reader(InputStream stream){
		reader = new BufferedReader(new InputStreamReader(stream));
	}
	
	public String nextLine(){
		try {
			this.line = new StringTokenizer("");
			return reader.readLine();
		} catch (IOException e) {
			throw new RuntimeException();
		}
	}
	
	public String next(){
		while (!line.hasMoreTokens()) line = new StringTokenizer(nextLine());
		return line.nextToken();
	}
	
	public int nextInt(){
		return Integer.parseInt(next());
	}
}
