import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Main {

	public static void main(String[] args) {
		Reader in = new Reader(System.in);
		PrintWriter out = new PrintWriter(System.out);

		int n = in.nextInt();
		if (n >= 7) {
			out.println(-1);
			out.close();
			return;
		}
		switch (n) {
		case 1:
			out.println(1);
			break;
		case 2:
			out.println("1 2");
			break;
		case 3:
			out.println("2 1 3");
			break;
		case 4:
			out.println("3 1 2 4");
			break;
		case 5:
			out.println(-1);
			break;
		case 6:
			out.println("5 1 4 2 6 3");
			break;
		}
		out.close();
	}

}

class Reader {
	BufferedReader reader;
	StringTokenizer line = new StringTokenizer("");

	public Reader(InputStream stream) {
		reader = new BufferedReader(new InputStreamReader(stream));
	}

	public String nextLine() {
		try {
			this.line = new StringTokenizer("");
			return reader.readLine();
		} catch (IOException e) {
			throw new RuntimeException();
		}
	}

	public String next() {
		while (!line.hasMoreTokens())
			line = new StringTokenizer(nextLine());
		return line.nextToken();
	}

	public int nextInt() {
		return Integer.parseInt(next());
	}
}
