import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.StringTokenizer;

public class Main {

	public static void main(String[] args) {
		Reader in = new Reader(System.in);
		PrintWriter out = new PrintWriter(System.out);

		String s = in.nextLine();
		ArrayList<String> b = new ArrayList<>();
		String[] tmp = s.split("(?<=[.!?])");
		for (int i = 0; i < tmp.length; i++) {
			if (!b.isEmpty()) {
				String prev = b.get(b.size() - 1);
				String tt = tmp[i].trim();
				if (prev.length() > 0 && tt.length() > 0) {
					char c = prev.charAt(prev.length() - 1);
					char fc = tt.charAt(0);
					if (c == '.' && fc >= 'a' && fc <= 'z') {
						b.remove(b.size() - 1);
						b.add(prev + tmp[i]);
						continue;
					}
				}
			}
			b.add(tmp[i]);
		}
		HashSet<String>[] h = new HashSet[b.size()];
		for (int i = 0; i < b.size(); i++) {
			h[i] = new HashSet<>();
			tmp = b.get(i).split("[ .!?]");
			for (String ss : tmp) {
				if (ss.length() > 0) {
					h[i].add(ss.toLowerCase());
				}
			}
		}
		int n = in.nextInt();
		for (int i = 0; i < n; i++) {
			String q = in.nextLine();
			String[] qq = q.toLowerCase().split(" ");
			out.print("Search results for \"");
			out.print(q);
			out.println("\":");
			for (int j = 0; j < b.size(); j++) {
				boolean ok = true;
				for (String qqq : qq) {
					if (qqq.length() == 0)
						continue;
					ok &= h[j].contains(qqq);
				}
				if (ok) {
					out.print("- \"");
					out.print(b.get(j).trim());
					out.println("\"");
				}
			}
		}
		out.close();
	}

}

class Reader {
	BufferedReader reader;
	StringTokenizer line = new StringTokenizer("");

	public Reader(InputStream stream) {
		reader = new BufferedReader(new InputStreamReader(stream));
	}

	public String nextLine() {
		try {
			this.line = new StringTokenizer("");
			return reader.readLine();
		} catch (IOException e) {
			throw new RuntimeException();
		}
	}

	public String next() {
		while (!line.hasMoreTokens())
			line = new StringTokenizer(nextLine());
		return line.nextToken();
	}

	public int nextInt() {
		return Integer.parseInt(next());
	}
}
