import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Main {

	public static void main(String[] args) {
		Reader in = new Reader(System.in);
		PrintWriter out = new PrintWriter(System.out);
		
		int n = in.nextInt();
		int m = in.nextInt();
		Trie root = new Trie();
		for (int i = 0; i < n; i++) {
			char [] num= in.next().toCharArray();
			int ans = 0;
			Trie c = root;
			for (int j = 0; j < m; j++) {
				int val = '1'-num[j];
				if (val==0 && c.ch[1]!=null) ans+=c.ch[1].val;
				if (c.ch[val]==null)break;
				c = c.ch[val];
			}
			out.println(ans);
			out.flush();
			c = root;
			for (int j = 0; j < m; j++) {
				int val = num[j]-'0';
				if (c.ch[val]==null) c.ch[val]=new Trie();
				c = c.ch[val];
				c.val++;
			}
		}
		out.close();
	}
	
	static class Trie{
		Trie[] ch = new Trie[2];
		int val = 0;
	}

}

class Reader{
	BufferedReader reader;
	StringTokenizer line = new StringTokenizer("");
	
	public Reader(InputStream stream){
		reader = new BufferedReader(new InputStreamReader(stream));
	}
	
	public String nextLine(){
		try {
			this.line = new StringTokenizer("");
			return reader.readLine();
		} catch (IOException e) {
			throw new RuntimeException();
		}
	}
	
	public String next(){
		while (!line.hasMoreTokens()) line = new StringTokenizer(nextLine());
		return line.nextToken();
	}
	
	public int nextInt(){
		return Integer.parseInt(next());
	}
}
