#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <utility>
#include <set>
#include <queue>
#include <map>
#include <memory.h>
#include <string>
#include <iomanip>

using namespace std;

string del_backspace(string & sentence) {
    string t = "";
    bool f = false;
    for (int i = 0; i < sentence.size(); ++i) {
        if (sentence[i] != ' ') {
            f = true;
        }
        if (f) {
            t += sentence[i];
        }
    }
    string ans = "";
    f = false;
    for (int i = t.size() - 1; i >= 0; --i) {
        if (t[i] != ' ') {
            f = true;
        }
        if (f) {
            ans += t[i];
        }
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    string text;
    getline(cin, text);
    string sentence = "", word = "";
    vector <string> list;
    map <string, vector <string>> mp;
    bool dot = false, sep = false;
    for (int i = 0; i < text.size(); ++i) {
        if (sep || dot) {
            if ((text[i] >= 'A' && text[i] <= 'Z') || (text[i] >= '0' && text[i] <= '9') || (sep && !dot) || (text[i] == '.' || text[i] == '!' || text[i] == '?')) {
                list.push_back(del_backspace(sentence));
                sentence = "";
                dot = false;
                sep = false;
            } else if (text[i] >= 'a' && text[i] <= 'z' && dot) {
                sep = false;
                dot = false;
            }
        }
        if (text[i] == '.' || text[i] == '!' || text[i] == '?') {
            sep = true;
            if (text[i] == '.') {
                dot = true;
            }
        }
        sentence += text[i];
    }
    list.push_back(del_backspace(sentence));
    sentence = "";
    dot = false;
    sep = false;
    for (int i = 0; i < list.size(); ++i) {
        sentence = list[i];
        for (int j = 0; j < sentence.size(); ++j) {
            if ((sentence[j] >= 'a' && sentence[j] <= 'z') || (sentence[j] >= 'A' && sentence[j] <= 'Z')) {
                word += sentence[j];
            } else if (!word.empty()) {
                for (int k = 0; k < word.size(); ++k) {
                    if (word[k] >= 'A' && word[k] <= 'Z') {
                        word[k] += 32;
                    }
                }
                mp[word].push_back(sentence);
                word = "";
            }
        }
    }
    int n;
    cin >> n;
    getline(cin, sentence);
    for (int i = 0; i < n; ++i) {
        getline(cin, sentence);
        map <string, int> cnt;
        int q = 0;
        for (int j = 0; j < sentence.size(); ++j) {
            if ((sentence[j] >= 'a' && sentence[j] <= 'z') || (sentence[j] >= 'A' && sentence[j] <= 'Z')) {
                word += sentence[j];
            } else if (!word.empty()) {
                ++q;
                for (int k = 0; k < word.size(); ++k) {
                    if (word[k] >= 'A' && word[k] <= 'Z') {
                        word[k] += 32;
                    }
                }
                for (int k = 0; k < mp[word].size(); ++k) {
                    cnt[mp[word][k]]++;
                }
                word = "";
            }
        }
        if (!word.empty()) {
            ++q;
            for (int k = 0; k < word.size(); ++k) {
                if (word[k] >= 'A' && word[k] <= 'Z') {
                    word[k] += 32;
                }
            }
            for (int k = 0; k < mp[word].size(); ++k) {
                cnt[mp[word][k]]++;
            }
            word = "";
        }
        cout << "Search results for " << char(34) << sentence << char(34) << ":" << endl;
        vector <string> cur;
        for (auto x : cnt) {
            string str = x.first;
            int q2 = x.second;
            if (q2 == q) {
                cur.push_back(str);
            }
        }
        for (int j = 0; j < list.size(); ++j) {
            for (int k = 0; k < cur.size(); ++k) {
                if (list[j] == cur[k]) {
                    cout << "- " << char(34) << cur[k] << char(34) << endl;
                }
            }
        }
    }
    return 0;
}
