#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ft first
#define sd second
#define all(x) begin((x)), end((x))
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))

typedef long long ll;
typedef pair<int, int> pii;

vector<int> a, lf, rg;

void solve()
{
    int n;
    scanf("%d", &n);

    a.resize(n);
    lf.resize(n);
    rg.resize(n);

    forn (i, n)
    {
        lf[i] = i - 1;
        rg[i] = i + 1;
    }
    lf[0] = rg[n - 1] = -1;

    for (int & i : a) scanf("%d", &i);

    int m;
    scanf("%d", &m);

    forn (k, m)
    {
        int i;
        scanf("%d", &i);
        --i;

        if (lf[i] != -1) rg[lf[i]] = rg[i];
        if (rg[i] != -1) lf[rg[i]] = lf[i];

        int prev = i, ans = 1;

        for (int j = rg[i]; j != -1; j = rg[j])
        {
            if (j != prev + 1 || a[i] - a[j] < j - i) break;
            ++ans;

            if (lf[j] != -1) rg[lf[j]] = rg[j];
            if (rg[j] != -1) lf[rg[j]] = lf[j];

            prev = j;
        }

        prev = i;

        for (int j = lf[i]; j != -1; j = lf[j])
        {
            if (j != prev - 1 || a[i] - a[j] < i - j) break;
            ++ans;

            if (lf[j] != -1) rg[lf[j]] = rg[j];
            if (rg[j] != -1) lf[rg[j]] = lf[j];

            prev = j;
        }

        printf("%d\n", ans);
    }
}

// #define LOCAL

int main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    //cin.tie(0);

    solve();

    return 0;
}
