#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ft first
#define sd second
#define all(x) begin((x)), end((x))
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))

const int INF = 1<<30;
typedef long long ll;
typedef pair<int, int> pii;

int dp[(1<<18) + 5];
int zk[105];
int zk_cost[105];

int to_mask(vector<int>& v)
{
    int ans = 0;
    for (int it : v)
        ans |= (1<<it);
    return ans;
}

void solve()
{
    int n, m;
    scanf("%d%d", &n, &m);
    vector<int> v;
    for (int i = 0; i < m; ++i)
    {
        int k;
        scanf("%d", &k);
        v.resize(k);
        for (int& it : v)
            scanf("%d", &it), it--;
        int c;
        scanf("%d", &c);
        zk[i] = to_mask(v);
        zk_cost[i] = c;
    }
    int max_mask = (1<<n)-1;
    for (int j = 1; j <= max_mask; ++j)
        dp[j] = INF;

    for (int i = 0; i < n; ++i)
        for (int j = max_mask; j >= 0; --j)
            if (!(j&zk[i]))
                dp[j|zk[i]] = min(dp[j|zk[i]], dp[j] + zk_cost[i]);

    if (dp[max_mask] == INF)
        dp[max_mask] = -1;

    printf("%d\n", dp[max_mask]);
}

#define LOCAL

int main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    //cin.tie(0);

    solve();

    return 0;
}
