#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ft first
#define sd second
#define all(x) begin((x)), end((x))
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))

typedef long long ll;
typedef pair<int, int> pii;

vector<vector<int> > g;
vector<int> sz;
vector<ll> d;
int n;

void get_dist(int v, int p, ll s)
{
    d[v] = s;
    for (int & u : g[v])
        if (u != p) get_dist(u, v, s + 1);
}

int get_sz(int v, int p)
{
    sz[v] = 1;
    for (int & u : g[v])
        if (u != p) sz[v] += get_sz(u, v);
    return sz[v];
}

ll get_ans(int v, int p, ll ans_p)
{
    ll res = ans_p + n - 2 * sz[v];
    ll ans = res;

    for (int & u : g[v])
        if (u != p) ans += get_ans(u, v, res);

    return ans;
}

void solve()
{
    scanf("%d", &n);

    g.resize(n);
    d.resize(n);
    sz.resize(n);

    forn (i, n - 1)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        g[a - 1].pb(b - 1);
        g[b - 1].pb(a - 1);
    }

    get_sz(0, 0);

    get_dist(0, 0, 0);
    ll d_sum = 0;
    forn (i, n) d_sum += d[i];

    ll ans = d_sum;
    for (int & u : g[0])
        ans += get_ans(u, 0, d_sum);

    printf("%lld", ans / 2);
}

// #define LOCAL

int main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
