#include<iostream>
#include<cstdio>
#include<cstring>
#include<set>
#include<vector>
#include<string>
#include<map>
#include<algorithm>
using namespace std;
typedef pair<int, int> P;
typedef long long ll;
typedef double db;
struct pt{
	db x, y;
	pt(){}
	pt(int x1, int y1){x=x1, y=y1;}
	pt operator+ (pt p){return pt(x+p.x, y+p.y);}
	pt operator- (pt p){return pt(x-p.x, y-p.y);}
	pt operator* (int d){return pt(d*x, d*y);}
	db operator^ (pt p){return x*p.y-y*p.x;}
	db mod(){return sqrt(x*x+y*y);}
	void in(){scanf("%lf%lf", &x, &y);}
	void out(){printf("%d %d\n", (int)x, (int)y);}
};
pt a[200111];
bool cmp(pt p1, pt p2){
	if(p1.y!=p2.y) return p1.y<p2.y;
	return p1.x<p2.x;
}
bool cmp1(pt p1, pt p2){
	return atan2(p1.y-a[0].y, p1.x-a[0].x)<atan2(p2.y-a[0].y, p2.x-a[0].x);
}
int main(){
	int n;
	cin>>n;
	for(int i=0; i<n; i++)
		a[i].in();
	sort(a, a+n, cmp);
	sort(a+1, a+n, cmp1);
	vector<pt>res;
	res.push_back(a[0]);
	res.push_back(a[1]);
	res.push_back(a[2]);
	for(int i=3; i<n; i++){
		while(res.size()>2 && ((a[i]-res.back())^(res.back()-res[res.size()-2]))>0)
			res.pop_back();
		res.push_back(a[i]);
	}
	db res1=0;
	pt ans1, ans2, ans3;
	for(int i=0; i<res.size(); i++){
		for(int j=i+1; j<res.size(); j++){
			for(int k=j+1; k<res.size(); k++){
				db S=fabs((res[j]-res[i])^(res[k]-res[i]))/2;
				if(S>res1){
					res1=S;
					ans1=res[i], ans2=res[j], ans3=res[k];
				}
			}
		}
	}
	ans1.out();
	ans2.out();
	ans3.out();
}
/*
5
1 5
-2 5
-1 2
4 -3
5 3
*/