#include <iostream>
#include <algorithm>
#include <map>
#include <string>
#include <vector>
#include <set>

using namespace std;

struct pt
{
	long long x,y;

	pt (){}

	pt (long long xx, long long yy) {x=xx; y=yy;}
};

bool vv1 (pt &a, pt &b, pt &c) {return (b.x-a.x)*(c.y-b.y) > (b.y-a.y)*(c.x-b.x);}

bool vv2 (pt &a, pt &b, pt &c) {return (b.x-a.x)*(c.y-b.y) < (b.y-a.y)*(c.x-b.x);}

long long vv (pt &a, pt &b, pt &c) {return (b.x-a.x)*(c.y-b.y) - (b.y-a.y)*(c.x-b.x);}

bool cmp (pt a, pt b) {return a.x<b.x || (a.x==b.x && a.y<b.y);}

vector <pt> h;

void bh (vector <pt> &w)
{
	sort(w.begin(),w.end(), &cmp);
	int n = w.size();

	pt A = w[0],
	   B = w[n-1];

	vector <pt> s1,s2;

	s1.push_back(A);
	s2.push_back(A);

	for (int i=1; i<n; i++) {
		if (vv1(A,B,w[i])) {
			while (s1.size()>=2 && !vv1(s1[s1.size()-2],w[i],s1[s1.size()-1])) {
				s1.pop_back();
			}
			s1.push_back(w[i]);
		}


		if (vv2(A,B,w[i])) {
			while (s2.size()>=2 && !vv2(s2[s2.size()-2],w[i],s2[s2.size()-1])) {
				s2.pop_back();
			}
			s2.push_back(w[i]);
		}
	}

	for (int i=0; i<s1.size(); i++) {
		h.push_back(s1[i]);
	}

	h.push_back(B);

	for (int i=s2.size()-1; i>=1; i--) {
		h.push_back(s2[i]);
	}

	
}
	

int main ()
{
	std::ios::sync_with_stdio(0);
	int n; cin >> n;

	vector <pt> w(n);

	for (int i=0; i<n; i++) {
		cin >> w[i].x >> w[i].y;
	}
	
	bh(w);
	
	int i1=0,i2=1,i3=2;

	long long ans=0;

	int a1=0,a2=1,a3=2;

	int tr = 0;

	int k=0;

	n = h.size();

	for (;;) {
		if(abs(vv(h[i1],h[i2],h[i3])) > ans) {
			ans = abs(vv(h[i1],h[i2],h[i3]));
			a1 = i1;
			a2 = i2;
			a3 = i3;

			
		}
		else {
			tr++;
		}

			

		if(tr%3==0) {
			i3++;
		}
		else if (tr%3==1) {
			i2 ++;
		}
		else {
			i1++;
		}

		if (i3>=n) {
			i3 = 0;
		}
		if (i2>=n) {
			i2=0;
		}
		if (i1>=n) {
			i1=0;
		}
		if(i2==i3) {break;}
		if(i1==i2) {break;}
		if(i3==i1) {break;}

		if(i1==n-1) {
			k++;
		}

		if(k==3) {
			break;
		}
	}

	cout << h[a1].x << " " << h[a1].y << "\n";
	cout << h[a2].x << " " << h[a2].y << "\n";
	cout << h[a3].x << " " << h[a3].y << "\n";

	system("pause");
}

/*

16
2 8
3 2
4 4
4 7
5 13
6 1
6 4
7 9
8 5
8 11
9 1
9 9
10 6
10 14
11 10
12 5
*/


/*
multimap<string,pair<string *,int>> mp;

void tolower(string &s){
	for(int t=0;t<s.length();t++){
		s[t]=tolower(s[t]);
	}
}

void index(const string& s){
	//cout<<"#"<<s<<'\n';
	static int w = 0;
	w++;
	int mtp = 0;

	string *ps = new string(s);
	size_t spos = 0;
	auto it = s.find_first_of(".!? ");
	
	while(it!=s.npos){
		if(spos!=it){
			string ts = s.substr(spos,it-spos);
			tolower(ts);
			mp.insert(make_pair(ts,make_pair(ps,w)));
			//cout<<s.substr(spos,it-spos)<<"|"<<*mp[s.substr(spos,it-spos)]<<'\n';
		}
		spos = it+1;
		it = s.find_first_of(".!? ",it+1);
	}
	if(spos!=it){
			string ts = s.substr(spos,it-spos);
			tolower(ts);
			mp.insert(make_pair(ts,make_pair(ps,w)));
			//cout<<s.substr(spos,it-spos)<<"|"<<*mp[s.substr(spos,it-spos)]<<'\n';
	}
};

void parse2(const string& s){
	//vector<string> p;
	int sp=0;
	int l=s.length();
	int cp=0;
	for(;cp<l;cp++){
		if(s[cp]=='.'){
			cp++;
			int tpos = cp;
			bool it = true;
			for(;cp<l && it;cp++){
				if(s[cp]>='a' && s[cp]<='z')it = false;
				else if(isalpha(s[cp]) || isdigit(s[cp]) || s[cp]=='.' || s[cp]=='?' || s[cp]=='!'){
					//p.push_back(s.substr(sp,tpos-sp));
					index(s.substr(sp,tpos-sp));
					sp=cp;
					it=false;
				}
			}
		}
	}
	if(sp!=s.npos)
		index(s.substr(sp));
};

void parse(const string& s){
	vector<string> p;

	size_t spos = 0;
	auto it = s.find_first_of("!?");
	
	while(it!=s.npos){
		if(spos!=it){
			p.push_back(s.substr(spos,it-spos+1));
		}
		spos = it+1;
		it = s.find_first_of("!? ",it+1);
	}

	if(spos!=s.npos)
		p.push_back(s.substr(spos));




	for(int t=0;t<p.size();t++){
		//cout<<"#"<<p[t]<<'\n';
		parse2(p[t]);
	}
};

void find(const string &s){
	map<pair<string *,int> sr;

	vector<string> word;
	int mtp = 0;
	size_t spos = 0;
	auto it = s.find_first_of(" ");
	
	while(it!=s.npos){
		if(spos!=it){
			string ts = s.substr(spos,it-spos);
			tolower(ts);
			if(ts==" " || ts=="")break;
			word.push_back(ts);
		}
		spos = it+1;
		it = s.find_first_of(" ",it+1);
	}
	if(spos!=it){
		string ts = s.substr(spos);
		tolower(ts);
		if(ts!=" " && ts!="")
			word.push_back(ts);
	}



	for(int wn = 0;wn<word.size();wn++){
		for(auto it = mp.find(word[wn]);it!=mp.end() && it->first==word[wn];it++)
			sr[it->second.first]++;
	}
	vector<pair<int,string*>> ev;
	for(auto it = sr.begin();it!=sr.end();it++)
		ev.push_back(it->second);
			if(it->second>=word.size())cout<<"- \""<<*(it->first)<<"\"\n";
};

int main(int,char**){
	std::ios::sync_with_stdio(0);

	string s;
	getline(cin,s);
	parse(s);

	getline(cin,s);
	int k = atoi(s.c_str());
	while(k--){
		getline(cin,s);
		cout<<"Search results for \""<<s<<"\":\n";
		find(s);
		//tolower(s);
		//for(auto it = mp.find(s);it!=mp.end() && it->first==s;it++)
		//cout<<"- \""<<*(it->second)<<"\"\n";
	}

	//parse("Hello everyone. I want 2 coffee if you have it. I like coffee very much.");

	system("pause");

	return 0;
}
*/