#include <iostream>

using namespace std;

struct mat2{
	unsigned long long d[2][2];
};

mat2& prod(const mat2& a,const mat2&b){
	mat2 r;
	r.d[0][0] = a.d[0][0]*b.d[0][0] + a.d[0][1]*b.d[1][0];
	r.d[1][0] = a.d[1][0]*b.d[0][0] + a.d[1][1]*b.d[1][0];
	r.d[0][1] = a.d[0][0]*b.d[0][1] + a.d[0][1]*b.d[1][1];
	r.d[1][1] = a.d[1][0]*b.d[0][1] + a.d[1][1]*b.d[1][1];
	return r;
};

mat2 bin_pow(mat2 a,int n){
	if(n==1)return a;
	if(n%2){
		return prod(a,bin_pow(a,n-1));
	}else{
		auto t = bin_pow(a,n/2);
		return prod(t,t);
	}
};

int fib(int n){
	if(n==0)return 0;
	if(n==1)return 1;
	int k = n/2;
	mat2 a;
	a.d[0][0] = 2;
	a.d[1][0] = 1;
	a.d[0][1] = 1;
	a.d[1][1] = 1;
	mat2 t;
	t = bin_pow(a,k);

	if(n%2)return t.d[0][0];
	else return t.d[0][1];
};

int main(int,char**){
	std::ios::sync_with_stdio(0);
	//unsigned long long a,b,c;
	//cin>>a>>b>>c;

	//a =fib(a);
	////cout<<a<<'\n';
	//b =fib(b);
	////cout<<b<<'\n';
	//c =fib(c);
	////cout<<c<<'\n';
	//long long D = b*b - 4*a*c;
	//if(D == 0){
	//	cout<<1;
	//}else if(D>0)cout<<2;
	//else cout<<0;

	int n; cin >> n;
	
if (n==1) {
cout << 1;
return 0;
}

	if (n==2) {
		cout << 2 << " " << 1;
		return 0;
	}

	if (n==3) {
		cout << 3 << " " << 1 << " " << 2;
		return 0;
	}

if (n==4) {
	cout << "3 1 2 4";
return 0;
}

	if (n==6) {
		cout << 4 << " " << 2 << " " << 6 << " " << 3 << " " << 1 << " " << 5;
		return 0;
	}
	
	cout << -1;

	system("pause");

	return 0;
}