#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

#include <stdio.h>

using namespace std;


	bool solve(const string &rhs, const string &lhs) {
		for (size_t k = 0; k < rhs.length(); k++) {
			char curi = rhs[k] - '0';
			char curj = lhs[k] - '0';
			if (curi + curj == 0) {
				return true;
			}
			else if (curi + curj == 1) {
				continue;
			}
			else if (curi + curj == 2) {
				return false;
			}
		}
		return true;
	}



void task() {
	int n,m;
	scanf("%d %d", &n, &m);

	vector<string> strs;

	for (size_t i = 0; i < n; i++) {
		int cnt = 0;
		char buf[100005];
		scanf("%s", buf);
		string str(buf);

		int l = 0, r = strs.size();
		while (l < r) {
			int m = (l + r) / 2;
			if (!solve(strs[m], str)) {
				r = m;
			}
			else {
				l = m+1;
			}
		}

		//auto it = lower_bound(strs.begin(), strs.end(), str, solve());

		printf("%d\n",strs.size() - l);
		fflush(stdout);

		strs.insert(lower_bound(strs.begin(), strs.end(), str), str);
	}
}


int main()
{

	task();
	return 0;
}
