#include <stdio.h>
#include <iostream>
#include <cmath>

using namespace std;


struct Point{
	int x,y;
};


double getDistance(Point p1, Point p2){
	return sqrt(double(p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
}

double ploshad(double P, double a, double b, double c)
{
	return sqrt(P*(P-a)*(P-b)*(P-c));
}


int main()
{
	int i;
	int n;
	Point *pts = new Point[200051];
	//Point pts[1000];
	Point zero;

	zero.x = 0;
	zero.y = 0;

	cin >> n;

	for (i=0; i<n; i++) {
		cin >> pts[i].x >> pts[i].y;
	}

	int bestIndex=0;
	double bestLength=-1., tmpLength;
	for (int i=0; i<n; i++) {
		tmpLength = getDistance(pts[i],zero);
		if (tmpLength>bestLength) {
			bestIndex = i;
			bestLength = tmpLength;
		}
	}
	
	int bestIndex2=0;
	double bestLength2=-1.;
	for (int i=0; i<n; i++) {
		tmpLength = getDistance(pts[i],pts[bestIndex]);
		if (tmpLength>bestLength2) {
			bestIndex2 = i;
			bestLength2 = tmpLength;
		}
	}

	/*int bestIndex3=0;
	double bestLength3=-1.;
	for (i=0; i<n; i++) {
		tmpLength = getDistance(pts[i],pts[bestIndex]) + getDistance(pts[i],pts[bestIndex2]);
		if (tmpLength>bestLength3) {
			bestIndex3 = i;
			bestLength3 = tmpLength;
		}
	}*/

	int bestIndex3=0;
	double bestLength3=-1.;
	double dlinaAB = getDistance(pts[bestIndex], pts[bestIndex2]);
	double l1, l2;
	double best_ploshad=-1;
	double tmp_ploshad;
	for (i=0; i<n; i++) 
	{
		l1 = getDistance(pts[i],pts[bestIndex]);
		l2 = getDistance(pts[i],pts[bestIndex2]);

		tmp_ploshad = ploshad(((l1+l2+dlinaAB)/2),l1,l2,dlinaAB);

		if (tmp_ploshad>best_ploshad) {
			bestIndex3 = i;
			best_ploshad = tmp_ploshad;
		}

	}
	cout << pts[bestIndex].x << ' ' << pts[bestIndex].y << endl;
	cout << pts[bestIndex2].x << ' ' << pts[bestIndex2].y << endl;
	cout << pts[bestIndex3].x << ' ' << pts[bestIndex3].y << endl;

	return 0;
}

