#include <stdio.h>
#include <iostream>
#include <cmath>

using namespace std;


struct Point{
	int x,y;
};


double getDistance(Point p1, Point p2){
	return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
}

double ploshad(double P, double a, double b, double c)
{
	return sqrt(P*(P-a)*(P-b)*(P-c));
}


int main()
{
	int i;
	int n;
	Point *pts = new Point[200051];

	Point zero;

	zero.x = 0;
	zero.y = 0;

	cin >> n;

	for (i=0; i<n; i++) {
		cin >> pts[i].x >> pts[i].y;
	}

	int bestIndex=0;
	double bestLength=-1., tmpLength;
	for (int i=0; i<n; i++) {
		tmpLength = getDistance(pts[i],zero);
		if (tmpLength>bestLength) {
			bestIndex = i;
			bestLength = tmpLength;
		}
	}
	
	int bestIndex2=0, bestIndex3=0;
	double bestPloshad=-1., tmpPloshad=-1.;
	double l1, l2;

	for (int i=0; i<n; i++) {
		double lenAB = getDistance(pts[i],pts[bestIndex]);

		for (int j=i; j<n; j++) {
			l1 = getDistance(pts[j],pts[bestIndex]);
			l2 = getDistance(pts[j],pts[i]);
			tmpPloshad = ploshad(((l1+l2+lenAB)/2),l1,l2,lenAB);
			
			if (tmpPloshad>bestPloshad) {
				bestIndex2 = i;
				bestIndex3 = j;
				bestPloshad = tmpPloshad;
			}
		}
	}
	

	cout << pts[bestIndex].x << ' ' << pts[bestIndex].y << endl;
	cout << pts[bestIndex2].x << ' ' << pts[bestIndex2].y << endl;
	cout << pts[bestIndex3].x << ' ' << pts[bestIndex3].y << endl;
	

	return 0;
}
