import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.StringTokenizer;


public class Main {
	static BigInteger[] b={new BigInteger("0"), new BigInteger("1"), new BigInteger("1"), new BigInteger("1")};
	static BigInteger[] e={new BigInteger("1"),new BigInteger("0"),new BigInteger("0"),new BigInteger("1")};
	static BigInteger[] s={new BigInteger("-1"),new BigInteger("-1"),new BigInteger("-1")};
	
	public static void main(String[] args) throws Exception{
		BufferedReader inp = new BufferedReader(new InputStreamReader(System.in));
		StringTokenizer str = new StringTokenizer(inp.readLine());
	    long i=Long.parseLong(str.nextToken()), j=Long.parseLong(str.nextToken()), k=Long.parseLong(str.nextToken());
	    BigInteger x,y;
	    long a;
	    a=Math.min(i, Math.min(j,k));
	    BigInteger[] ech = fib(a);
	    x = ech[0]; y = ech[1];
	    if (a == i) s[0] = x;
	    else if (a == j) s[1] = x;
	    else if (a == k) s[2] = x;
	    if (a + 1 == i) s[0] = y;
	    else if (a + 1 == j) s[1] = y;
	    else if (a + 1 == k) s[2] = y;
	    if (a + 2 == i) s[0] = x.add(y);
	    else if (a + 2 == j) s[1] = x.add(y);
	    else if (a + 2 == k) s[2] = x.add(y);

	    x = s[1].pow(2);
	    y = s[0].multiply(s[2].multiply(BigInteger.valueOf(4)));
	    //System.out.println(x + " " + y + " " + s[0] + " "+ s[1] +" "+s[2]);
	    if (x.equals(y)) System.out.println(1);
	    else if (x.compareTo(y) > 0) System.out.println(2);
	    else System.out.println(0);
	}
	
	public static BigInteger[] fib(long n){
		BigInteger[] r = matpow(b, n);
		BigInteger[] z = {r[2], r[3]};
		return z;
	}
	
	public static BigInteger[] matpow(BigInteger[] a, long n) {
		if (n == 0)
	        return e;
		BigInteger[] z, r = new BigInteger[4];
	    if ((n & 1) == 1) {
	        z = matpow(a, n - 1);
	        r[0] = a[0].multiply(z[0]).add(a[1].multiply(z[2]));
	        r[1] = a[0].multiply(z[1]).add(a[1].multiply(z[3]));
	        r[2] = a[2].multiply(z[0]).add(a[3].multiply(z[2]));
	        r[3] = a[2].multiply(z[1]).add(a[3].multiply(z[3]));
	    }
	    else {
	        z = matpow(a, n >> 1);
	        r[0] = z[0].multiply(z[0]).add(z[1].multiply(z[2]));
	        r[1] = z[0].multiply(z[1]).add(z[1].multiply(z[3]));
	        r[2] = z[2].multiply(z[0]).add(z[3].multiply(z[2]));
	        r[3] = z[2].multiply(z[1]).add(z[3].multiply(z[3]));
	    }
	    return r;
	}

}
