#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

int cout_matrix(vector< vector<int> > &v, int n) {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cout << v[i][j] << " ";
		}
		cout << "\n";
	}
	return 0;
}

int cout_matrix2(vector< vector<int> > &v, int n) {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cout << v[j][i] << " ";
		}
		cout << "\n";
	}
	return 0;
}

int mat_lines(vector< vector<int> > &v, int n) {
	int num = 1;
	for (int i = 0; i < n; ++i) {
		if (i % 2 == 0) {
			for (int j = 0; j < n; ++j) {
				v[i][j] = num++;
			}
		} else {
			for (int j = n - 1; j >= 0; --j) {
				v[i][j] = num++;
			}
		}
	}
	return 0;
}

int mat_spiral(vector< vector<int> > &v, int n) {
	int num = 1, pos = 1, i = 0, j = 0;
	while (num <= n*n) {
		v[i][j] = num++;
		if (pos == 1) {
			if (j + 1 < n && v[i][j + 1] == 0) {
				j += 1;
			} else {
				i += 1;
				pos = 2;
			}
		} else if (pos == 2) {
			if (i + 1 < n && v[i + 1][j] == 0) {
				i += 1;
			} else {
				j -= 1;
				pos = 3;
			}
		} else if (pos == 3) {
			if (j - 1 >= 0 && v[i][j - 1] == 0) {
				j -= 1;
			}
			else {
				i -= 1;
				pos = 4;
			}
		} else if (pos == 4) {
			if (i - 1 >= 0 && v[i - 1][j] == 0) {
				i -= 1;
			}
			else {
				j += 1;
				pos = 1;
			}
		}
	}
	return 0;
}



int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int n, a;
	cin >> n >> a;
	vector< vector<int> > v(n, vector<int>(n));	
	if (a == 1 || a == 2) {
		mat_lines(v,n);
	} else {
		mat_spiral(v,n);
	}
	if (a % 2 == 0) {
		cout_matrix2(v, n);
	} else {
		cout_matrix(v, n);
	}
	return 0;
}
